#version 330 core

in vec3 fragmentColor;
in vec3 fragmentNormal;
in vec3 fragmentLight;
in vec3 fragmentEye;
in float fragmentShine;

out vec4 color;

uniform mat4 projection, view, translate, rotate;
uniform vec4 lightPosition;
uniform vec4 ambientRaw, diffuseRaw, specularRaw;

void main()
{
	vec3 normal = normalize(fragmentNormal);
	vec3 eye = normalize(fragmentEye);
	vec3 light = normalize(fragmentLight);

	vec3 H = normalize( light + eye);
	
	//my home computer doesn't complain but adelphi and my surface do so just shut up glsl by making a temp variable.
	vec4 temp;
	temp.xyz = fragmentColor.xyz;
	temp.w = 1.0;
	vec4 ambient =  ambientRaw * temp;

	float Kd = max(dot(light, normal), 0.0);
	//note you could add a number to increase and decrease the intensity, but it gets ugly really quick
    vec4 diffuse = Kd * diffuseRaw;
	   
    float Ks = pow(max(dot(normal, H), 0.0), fragmentShine);
    vec4 specular = Ks*specularRaw;

	// discard the specular highlight if the light's behind the vertex
    if( dot(light, normal) < 0.0 ) {
	specular = vec4(0.0, 0.0, 0.0, 1.0);
    }
   
   color = ambient + diffuse + specular;
}