#version 330 core


layout(location = 0) in vec4 vPosition;
layout(location = 1) in vec3 vertexColor;
layout(location = 2) in vec3 normals;
layout(location = 3) in float vShine;


uniform mat4 projection, view, translate, rotate;
uniform vec4 lightPosition;
uniform vec4 ambientRaw, diffuseRaw, specularRaw;

out vec3 fragmentColor;
out vec3 fragmentNormal;
out vec3 fragmentEye;
out vec3 fragmentLight;
out float fragmentShine;

void main()
{
	vec4 modelview = view * rotate * translate * vPosition/vPosition.w;
	fragmentNormal = normals;
	fragmentEye = modelview.xyz;
	fragmentLight = lightPosition.xyz;


	if( lightPosition.w != 0.0)
	{
		fragmentLight = lightPosition.xyz - vPosition.xyz;
	}

    gl_Position = projection * modelview;
	fragmentColor = vertexColor;
	fragmentShine = vShine;
}