/************************************************************************
Daniel Greco
This header will contains all the necessary methods for helperfunctions.cpp
It will also contain constants.
************************************************************************/
#ifndef _HELPERFUNCTIONS_
#define	_HELPERFUNCTIONS_

#include "Angel.h"
#include <cstdlib>
#include <cmath>


/******************************
CONSTANTS
*******************************/
#define SCREEN_WIDTH 1024
#define SCREEN_HEIGHT 768
#define CIRCLE_RADIUS .5
#define SECTION_RADIUS .1
const vec3 RED = vec3(1.0, 0, 0);
const vec3 GREEN = vec3(0, 1.0, 0);
const vec3 BLUE = vec3(0, 0, 1.0);
const vec3 WHITE = vec3(1.0, 1.0, 1.0);
const vec3 BLACK = vec3(0.0, 0.0, 0.0);
const double TORAD  = M_PI / 180.0;

/*******************************
Methods
********************************/
vec3 randomColor();
void screenToOpenGL(int x, int y);
void createTorus();
void createColors();
void createCube();
void createCube(GLfloat offset, vec3 color);
void createCube(GLfloat xoffset, GLfloat yoffset, GLfloat zoffset, vec3 color);
void createCheckerCube(GLfloat offset, vec3 color);
void makeFarTooManyCubes(int numCubes);



#endif