/************************************************************************
Daniel Greco
Contains the definition of the class points.  Points will allow the user
to quickly add and maintain points, until they are ready to be added
to the gpu.
************************************************************************/
#ifndef _POINTS_H
#define _POINTS_H

#include <list>
#include "VectorCoords.h"
#include "Shapes.h"
#include "Angel.h"



class Points
{
public:
			Points();
			~Points();
	bool	init();
	bool	addToList(vec3 newItem, vec3 color);
	bool	addToList(vec3 newItem, vec3 color, vec3 normals);
	bool	addToList(vec3 newItem, vec3 color, vec3 normals, vec2 uvs);
	void	addShine(const GLfloat shine);
	void	purgeQueue();
	void    clearArrays();
	void	incCurPoints() {++curPoints;}
	void	resetCurPoints() {curPoints = 0;}

	//getters
	int		getVecSize() { return vectors->getSize();}
	VectorCoords *const getVectors() { return vectors;}
	
private:
	//bad name but it holds all the user clicks
	std::list<vec3> *userPoints;
	std::list<vec3> *colors;
	std::list<vec3> *normals;
	std::list<vec2> *uvs;
	std::list<float> *shines;

	bool			 purge;
	int curPoints;

	VectorCoords	*vectors;

};

#endif