#include "Shapes.h"


Shapes::Shapes(void)
{
}


Shapes::~Shapes(void)
{
	delete nVertices;
	delete sPoints;
	delete [] nVertArr;
	delete [] sPoinArr;
}

bool Shapes::initialize()
{
	nVertices = new std::vector<int>();
	sPoints = new std::vector<int>();
	sPoints->push_back(0);
	nVertArr = NULL;
	sPoinArr = NULL;
	genSPointsArray();
	genNumArray();
	return true;
}

void Shapes::clear()
{
	nVertices->clear();
	sPoints->clear();
	sPoints->push_back(0);

}

void Shapes::genNumArray()
{
	if(nVertArr != NULL)
	{
		delete [] nVertArr;
	}
	//the number of shapes and starting points should be equivalent!
	nVertArr = new int[nVertices->size()];
	int i = 0;
	for(std::vector<int>::iterator iter = nVertices->begin(); iter != nVertices->end(); ++iter, ++i)
	{
		nVertArr[i] = *iter;
	}
}

void Shapes::genSPointsArray()
{
	if(sPoinArr != NULL)
	{
		delete [] sPoinArr;
	}
	sPoinArr = new int[sPoints->size()];
	int i = 0;
	for(std::vector<int>::iterator iter = sPoints->begin(); iter != sPoints->end(); ++iter, ++i)
	{
		sPoinArr[i] = *iter;
	}
}

void Shapes::addNewShape(int numVertices)
{
	nVertices->push_back(numVertices);
	int start = *(--sPoints->end());
	start += numVertices;
	sPoints->push_back(start);
	genNumArray();
	genSPointsArray();
}