/************************************************************************
Daniel Greco
Contains the implementation of class vectorcoords
************************************************************************/
#include "VectorCoords.h"


//constructor for vectorcoords
VectorCoords::VectorCoords() : initialized(false), size(0)
{}

//destructor for vectorcoords
VectorCoords::~VectorCoords()
{
	//make sure they've been initialized
	if(vecArray != NULL)
	{
		delete [] vecArray;
		vecArray = NULL;
	}
	if(colorArray != NULL)
	{
		delete [] colorArray;
		colorArray = NULL;
	}
	if(numVertices != NULL)
	{
		delete [] numVertices;
		numVertices = NULL;
	}
	if(sPoints != NULL)
	{
		delete [] sPoints;
		sPoints = NULL;
	}
	if(normalArray != NULL)
	{
		delete [] normalArray;
		normalArray = NULL;
	}

	if(uvsArray != NULL)
	{
		delete [] uvsArray;
		uvsArray = NULL;
	}

	if(shineArray != NULL)
	{
		delete [] shineArray;
		shineArray = NULL;
	}

}

//init or reinit the arrays
bool VectorCoords::init(int size)
{
	if(!initialized)
	{
		initialized = true;
	}
	else
	{
		delete [] vecArray;
		delete [] colorArray;
		delete [] numVertices;
		delete [] sPoints;
		delete [] normalArray;
		delete [] uvsArray;
		delete [] shineArray;
		vecArray = NULL;
		colorArray = NULL;
		numVertices = NULL;
		sPoints = NULL;
		normalArray = NULL;
		uvsArray = NULL;
		shineArray = NULL;
	}
	//make sure it's a valid size.
	if(size >= 1)
	{
		this->size = size;
		vecArray = new vec3[size];
		colorArray = new vec3[size];
		numVertices = new int[size];
		sPoints  = new int [size];
		normalArray = new vec3[size];
		uvsArray = new vec2[size];
		shineArray = new float[size];
	}
	else
	{
		initialized = false;
		return false;
	}
	return true;
}

//delete everything known to man
void VectorCoords::clear()
{
	delete [] vecArray;
	delete [] colorArray;
	delete [] numVertices;
	delete [] sPoints;
	delete [] normalArray;
	delete [] uvsArray;
	delete [] shineArray;
	vecArray = NULL;
	colorArray = NULL;
	numVertices = NULL;
	sPoints = NULL;
	normalArray = NULL;
	uvsArray = NULL;
	shineArray = NULL;
	size = 0;
}