/************************************************************************
Daniel Greco
Contains the definition of the class VectorCoords. VectorCoords will
simply hold all the arrays that are going to be sent over to the GPU

Note: UVS array isn't used but is kept in primarily to allow me to 
fix texturing and get it working after this semester is over.
************************************************************************/

#ifndef _VECTOR_COORDS
#define _VECTOR_COORDS
#include "Angel.h"


class VectorCoords
{
public:
	VectorCoords();
	~VectorCoords();
	bool	init(int size);
	int		getSize() {return size;}
	void	clear();
	vec3 *const getVecArray() {return vecArray;}
	vec3 *const getColorArray() {return colorArray;} 
	vec3 *const getNormalArray() {return normalArray;}
	vec2 *const getUVSArray() {return uvsArray;}
	float *const getShineArray() {return shineArray;}

private:
	bool initialized;
	int size;
	vec3 *vecArray;
	vec3 *colorArray;
	vec3 *normalArray;
	vec2 *uvsArray;
	float *shineArray;
	int  *sPoints;
	int * numVertices;
};
#endif